/* FILE TEST.C */

/* test for rcsc - retargetable concurrent smallc compiler */
/* use with SX28_16.M4 to create SX28 sasm file            */

/* NOTE: rcsc variables names and function names are truncated to 8 characters !! */

  /* the following are the port's latch and direction registers */
  /* these are assigned negative addresses -18 to -1            */ 
  /* and must be present before any other variable              */

  /* 8bit ports (RC, RD and RE are ram for SX18, RD and RE are ram for SX28 */
  unsigned char RADIR,RBDIR,RCDIR;
  unsigned char RDDIR,REDIR; /* currently not supported by SxSim */
  unsigned char RA,RB,RC,RD,RE;

  /* 16bit ports (combined 8bit ports) */
  unsigned int RBCDIR;
  unsigned int RDEDIR; /* currently not supported by SxSim */
  unsigned int RBC,RDE;

  /* first the global definitions */
  char ca[32];  /*  32, ram[00h]-ram[1Fh] */
  int i,j;      /*   4, ram[20h]-ram[23h] */
  int ia[10];   /*  20, ram[24h]-ram[37h] */

/* to do:
  special #defines:
   stacksize,device,oschs1,turbo,stackx,optionx,freq,id
*/

  /* then the interrupt routine */

sxintrpt () {
  /* this is the interrupt routine - must be present   */
  /* this must be the first function so its entry is in the lower half of page */
  /* also, the name is reserved       */
}

  /* then the other functions, including main */

/* as there is no commandline, main has no arguments */
main () {
  char k; int p, q, r[6];

  k='A'; /* for stack integrity check */
  RBC = 0x1234;
  RDE = RBC;
  RA -= 5;
  RB=12;
  RCDIR=14;
  RBCDIR=443;
  test2(&p); /* pass address of p, test2 makes p = 128 */
  q = test3(); /* test3 returns 4 */
  i=p;
  j=q;

  /* set breakpoint in the sasm file here and check rambytes 0Fh-12h */

  /* try all operators */
  ia[0] = i + j;  /*  132, ram[24h]=84h, ram[25h]=0 */
  ia[1] = i - j;  /*  124, ram[26h]=7Ch, ram[27h]=0 */
  ia[2] = i * j;  /*  512, ram[28h]=0,   ram[29h]=2 */
  ia[3] = i / j;  /*   32, ram[2Ah]=20h, ram[2Bh]=0 */
  ia[4] = i % j;  /*    0, ram[2Ch]=0,   ram[2Dh]=0 */
  ia[5] = i ^ j;  /*  132, ram[2Eh]=84h, ram[2Fh]=0 */
  ia[6] = i & j;  /*    0, ram[30h]=0,   ram[31h]=0 */
  ia[7] = i | j;  /*  132, ram[32h]=84h, ram[33h]=0 */
  ia[8] = i << j; /* 2048, ram[34h]=0,   ram[35h]=8 */
  ia[9] = i >> j; /*    8, ram[36h]=8,   ram[37h]=0 */

  /* set breakpoint in the sasm file here and check rambytes 13h-26h */

  j = 1;  /* 1 */
  j += 1; /* 2 */
  j -= 1; /* 1 */
  j *= 2; /* 2 */
  j /= 2; /* 1 */
  j %= 8; /* 1 */
  j ^= 7; /* 6 */
  j &= 3; /* 2 */
  j |= 1; /* 3 */ /* check j at ram[11h] and ram[12h] */

  /* M4 generates EOF in argument listing error when using array[constant] */
  /* workaround for now: assign constant to dummy local int                */
  i=10;
  if (i <  11) {ca[q=0]=1;}  /* 1 */
  if (i >  11) {ca[q=1]=1;}  /* 0 */
  if (i <= 11) {ca[q=2]=1;}  /* 1 */
  if (i >= 11) {ca[q=3]=1;}  /* 0 */
  if (i == 11) {ca[q=4]=1;}  /* 0 */
  if (i != 11) {ca[q=5]=1;}  /* 1 */
  i=11;
  if (i <  11) {ca[q=8]=1;}  /* 0 */
  if (i >  11) {ca[q=9]=1;}  /* 0 */
  if (i <= 11) {ca[q=10]=1;} /* 1 */
  if (i >= 11) {ca[q=11]=1;} /* 1 */
  if (i == 11) {ca[q=12]=1;} /* 1 */
  if (i != 11) {ca[q=13]=1;} /* 0 */
  i=12;
  if (i <  11) {ca[q=16]=1;} /* 0 */
  if (i >  11) {ca[q=17]=1;} /* 1 */
  if (i <= 11) {ca[q=18]=1;} /* 0 */
  if (i >= 11) {ca[q=19]=1;} /* 1 */
  if (i == 11) {ca[q=20]=1;} /* 0 */
  if (i != 11) {ca[q=21]=1;} /* 1 */
  i=-2;
  if (i <  0) {ca[q=24]=1;}  /* 1 */
  if (i >  0) {ca[q=25]=1;}  /* 0 */
  if (i <= 0) {ca[q=26]=1;}  /* 1 */
  if (i >= 0) {ca[q=27]=1;}  /* 0 */
  if (i == 0) {ca[q=28]=1;}  /* 0 */
  if (i != 0) {ca[q=29]=1;}  /* 1 */

  /* set breakpoint in the sasm file here and check rambytes 01h-0Eh */

  while (1) ; /* always keep forever loop in main */

}

test2(u) int *u; {
  *u = 128;
}

test3 () {
  return 4;
}

/* end */
